/* Copyright (C) 1999 Masanao Izumo <mo@goice.co.jp>
 * Version: 1.0
 * LastModified: Dec 25 1999
 * This library is free.  You can redistribute it and/or modify it.
 */

/*
 * Interfaces:
 * b64 = base64encode(data);
 * data = base64decode(b64);
 */


var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

var base64DecodeChars = new Array(
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
    -1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
    -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1);

function base64encode(str) {
    var out, i, len;
    var c1, c2, c3;

    len = str.length;
    i = 0;
    out = "";
    while(i < len) {
	c1 = str.charCodeAt(i++) & 0xff;
	if(i == len)
	{
	    out += base64EncodeChars.charAt(c1 >> 2);
	    out += base64EncodeChars.charAt((c1 & 0x3) << 4);
	    out += "==";
	    break;
	}
	c2 = str.charCodeAt(i++);
	if(i == len)
	{
	    out += base64EncodeChars.charAt(c1 >> 2);
	    out += base64EncodeChars.charAt(((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4));
	    out += base64EncodeChars.charAt((c2 & 0xF) << 2);
	    out += "=";
	    break;
	}
	c3 = str.charCodeAt(i++);
	out += base64EncodeChars.charAt(c1 >> 2);
	out += base64EncodeChars.charAt(((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4));
	out += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6));
	out += base64EncodeChars.charAt(c3 & 0x3F);
    }
    return out;
}

function base64decode(str) {
    var c1, c2, c3, c4;
    var i, len, out;

    len = str.length;
    i = 0;
    out = "";
    while(i < len) {
	/* c1 */
	do {
	    c1 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
	} while(i < len && c1 == -1);
	if(c1 == -1)
	    break;

	/* c2 */
	do {
	    c2 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
	} while(i < len && c2 == -1);
	if(c2 == -1)
	    break;

	out += String.fromCharCode((c1 << 2) | ((c2 & 0x30) >> 4));

	/* c3 */
	do {
	    c3 = str.charCodeAt(i++) & 0xff;
	    if(c3 == 61)
		return out;
	    c3 = base64DecodeChars[c3];
	} while(i < len && c3 == -1);
	if(c3 == -1)
	    break;

	out += String.fromCharCode(((c2 & 0XF) << 4) | ((c3 & 0x3C) >> 2));

	/* c4 */
	do {
	    c4 = str.charCodeAt(i++) & 0xff;
	    if(c4 == 61)
		return out;
	    c4 = base64DecodeChars[c4];
	} while(i < len && c4 == -1);
	if(c4 == -1)
	    break;
	out += String.fromCharCode(((c3 & 0x03) << 6) | c4);
    }
    return out;
}

var passedDocument = null;
var cookieList = null;
var cookieManager = null;
var cookieValue = null;
var cookieDomain = null;
var cookiePath = null;
var cookieName = null;
var cookieService = null;


function createLine(col1, col2, col3, value) {
  var cel1 = document.createElement("listcell");
  var cel2 = document.createElement("listcell");
  var cel3 = document.createElement("listcell");
  cel1.setAttribute("label", col1);
  cel2.setAttribute("label", col2);
  cel3.setAttribute("label", col3);
  cel1.setAttribute("id", "col1");
  cel2.setAttribute("id", "col2");
  cel3.setAttribute("id", "col3");
  var newLine = document.createElement("listitem");
  newLine.setAttribute("value", value);
  newLine.appendChild(cel1);
  newLine.appendChild(cel2);
  newLine.appendChild(cel3);
  return newLine;
}

function clearCookieList() {
	var numCookies = cookieList.childNodes.length;
	// The two first childs of this listbox are the
        // headers and the container... we don't really
	// want to remove these, do we?
	numCookies-=2;
        if ( numCookies ) {
	  while ( numCookies-- )
		cookieList.removeChild(cookieList.lastChild);
        }
}

function updateCookieList() {

   clearCookieList();

   try {

    cookieValue = document.getElementById("cookievalue");
    cookieDomain = document.getElementById("cookiedomain");
    cookiePath = document.getElementById("cookiepath");
    cookieName = document.getElementById("cookiename");

    var iter = cookieManager.enumerator;

    while (iter.hasMoreElements()){
      var cookie = iter.getNext();
      if (cookie instanceof Components.interfaces.nsICookie){
          cookieList.appendChild(createLine(cookie.host, 
                                            cookie.path, 
                                            cookie.name, 
                                            cookie.value));
      }
    }

   } catch ( e ) { alert("Error:\n\n"+e) ; }

}

function onLoad()  {

   // Initialize the objects we'll be using...

   
   cookieList = document.getElementById("cookielist");

   cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
                        .getService(Components.interfaces.nsICookieManager2);

   cookieService = Components.classes["@mozilla.org/cookieService;1"]
                        .getService(Components.interfaces.nsICookieService);

   updateCookieList();
   return true;

}

function cookieSelected() {
   col1 = cookieList.selectedItem.getElementsByAttribute("id", "col1")[0];
   col2 = cookieList.selectedItem.getElementsByAttribute("id", "col2")[0];
   col3 = cookieList.selectedItem.getElementsByAttribute("id", "col3")[0];
   cookieDomain.value = col1.getAttribute("label");
   cookiePath.value = col2.getAttribute("label");
   cookieName.value = col3.getAttribute("label");
   cookieValue.value = cookieList.selectedItem.value;
}

function coeditExit() {
  window.close();
}

function makeURI(myDomain, myPath) {

  var myURI = Components.classes['@mozilla.org/network/standard-url;1']
                   .createInstance(Components.interfaces.nsIURI);
                                                                                
  myURI.host = myDomain;
  myURI.path = myPath;

  return myURI;

}

function getSelectedText(component) {
  { 

    var bits = [component.value,'','','']; 
    if(component.selectionStart != component.selectionEnd)
      { 
	bits[1] = component.value.substr(0,component.selectionStart);
        bits[2] = component.value.substr(component.selectionStart, component.selectionEnd-component.selectionStart);
        bits[3] = component.value.substr(component.selectionEnd);
      }
    else 
      {
       bits[1] = "";
       bits[2] = component.value;
       bits[3] = ""; 
      }
    return bits;
  }

}

function unescapeValue() {
  bits = getSelectedText(cookieValue);
  cookieValue.value = bits[1]+unescape(bits[2])+bits[3];
}

function escapeValue() {
  bits = getSelectedText(cookieValue);
  cookieValue.value = bits[1]+escape(bits[2])+bits[3];
}

function b64Encode() {
  try {
    bits = getSelectedText(cookieValue);
    cookieValue.value = bits[1]+base64encode(bits[2])+bits[3];
  } catch (e) { alert("Errore: "+e); }
}

function b64Decode() {
  try {
    bits = getSelectedText(cookieValue);
    cookieValue.value =  bits[1]+base64decode(bits[2])+bits[3];
  } catch (e) { alert("Errore: "+e); }
}

// Taken verbatim from 
// http://www.the-cool-place.co.uk/javascript/tutorial/javascript3.html

function getexpirydate( nodays){
  var UTCstring;
  Today = new Date();
  nomilli=Date.parse(Today);
  Today.setTime(nomilli+nodays*24*60*60*1000);
  UTCstring = Today.toUTCString();
  return UTCstring;
}

function cookieChanged() {
   try {
     ckDomain = cookieDomain.value;     
     ckPath = cookiePath.value;     
     ckName = cookieName.value;     
     ckValue = cookieValue.value;

     alert("Changing "+ckName+" ("+ckDomain+","+ckPath+") to "+ckValue);

     var ckURI = makeURI(ckDomain, ckPath);
     cookieManager.remove(ckDomain, ckName, ckPath, false);
     cookieService.setCookieString(ckURI, 
                                   null, 
                                   ckName+"="+ckValue
                                   +"; expires="+getexpirydate(365)
                                   +"; path="+ckPath+"; domain="
                                   +ckDomain,null);

   } catch (e) { alert("Error:\n\n"+e); }

   updateCookieList();

}

function cookieCreate() {
   try {

     ckDomain = cookieDomain.value;     
     ckPath = cookiePath.value;     
     ckName = cookieName.value;     
     ckValue = cookieValue.value;

     var ckURI = makeURI(ckDomain, ckPath);

     alert("Creating "+ckName+" ("+ckDomain+","+ckPath+") = "+ckValue);

     cookieService.setCookieString(ckURI, 
                                   null, 
                                   ckName+"="+ckValue
                                   +"; expires="+getexpirydate(365)
                                   +"; path="+ckPath+"; domain="
                                   +ckDomain,null);

   } catch (e) { alert("Error:\n\n"+e); }

   updateCookieList();
}
